AbstractExecutionThreadService
Date: 2016-05-24

com.google.common.util.concurrent

## Class AbstractExecutionThreadService

- java.lang.Object
- - com.google.common.util.concurrent.AbstractExecutionThreadService

- All Implemented Interfaces:
    Service

      @Beta
      public abstract class AbstractExecutionThreadService
      extends java.lang.Object
      implements Service

  Base class for services that can implement `startUp()`, `run()` and `shutDown()` methods. This class uses a single thread to execute the service; consider `AbstractService` if you would like to manage any threading manually.
  Since:
    1.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.google.common.util.concurrent.Service

      `Service.Listener, Service.State`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractExecutionThreadService()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(Service.Listener listener, java.util.concurrent.Executor executor)` Registers a `Service.Listener` to be executed on the given executor.
    `void` | `awaitRunning()` Waits for the `Service` to reach the running state.
    `void` | `awaitRunning(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach the running state for no more than the given time.
    `void` | `awaitTerminated()` Waits for the `Service` to reach the terminated state.
    `void` | `awaitTerminated(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
    `protected java.util.concurrent.Executor` | `executor()` Returns the `Executor` that will be used to run this service.
    `java.lang.Throwable` | `failureCause()` Returns the `Throwable` that caused this service to fail.
    `boolean` | `isRunning()` Returns `true` if this service is running.
    `protected abstract void` | `run()` Run the service.
    `protected java.lang.String` | `serviceName()` Returns the name of this service.
    `protected void` | `shutDown()` Stop the service.
    `Service` | `startAsync()` If the service state is `Service.State.NEW`, this initiates service startup and returns immediately.
    `protected void` | `startUp()` Start the service.
    `Service.State` | `state()` Returns the lifecycle state of the service.
    `Service` | `stopAsync()` If the service is starting or running, this initiates service shutdown and returns immediately.
    `java.lang.String` | `toString()`
    `protected void` | `triggerShutdown()` Invoked to request the service to stop.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractExecutionThreadService

          protected AbstractExecutionThreadService()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### startUp

          protected void startUp()
                          throws java.lang.Exception

      Start the service. This method is invoked on the execution thread.

      By default this method does nothing.

      Throws:
        `java.lang.Exception`

    - #### run

          protected abstract void run()
                               throws java.lang.Exception

      Run the service. This method is invoked on the execution thread. Implementations must respond to stop requests. You could poll for lifecycle changes in a work loop:

             public void run() {
               while (isRunning()) {
                 // perform a unit of work
               }
             }

      ...or you could respond to stop requests by implementing `triggerShutdown()`, which should cause `run()` to return.
      Throws:
        `java.lang.Exception`

    - #### shutDown

          protected void shutDown()
                           throws java.lang.Exception

      Stop the service. This method is invoked on the execution thread.

      By default this method does nothing.

      Throws:
        `java.lang.Exception`

    - #### triggerShutdown

          protected void triggerShutdown()

      Invoked to request the service to stop.

      By default this method does nothing.

    - #### executor

          protected java.util.concurrent.Executor executor()

      Returns the `Executor` that will be used to run this service. Subclasses may override this method to use a custom `Executor`, which may configure its worker thread with a specific name, thread group or priority. The returned executor's `execute()` method is called when this service is started, and should return promptly.

      The default implementation returns a new `Executor` that sets the name of its threads to the string returned by `serviceName()`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### isRunning

          public final boolean isRunning()

      Description copied from interface: `Service`
      Returns `true` if this service is running.
      Specified by:
        `isRunning` in interface `Service`

    - #### state

          public final Service.State state()

      Description copied from interface: `Service`
      Returns the lifecycle state of the service.
      Specified by:
        `state` in interface `Service`

    - #### addListener

          public final void addListener(Service.Listener listener,
                         java.util.concurrent.Executor executor)

      Description copied from interface: `Service`
      Registers a `Service.Listener` to be executed on the given executor. The listener will have the corresponding transition method called whenever the service changes state. The listener will not have previous state changes replayed, so it is suggested that listeners are added before the service starts.

      `addListener` guarantees execution ordering across calls to a given listener but not across calls to multiple listeners. Specifically, a given listener will have its callbacks invoked in the same order as the underlying service enters those states. Additionally, at most one of the listener's callbacks will execute at once. However, multiple listeners' callbacks may execute concurrently, and listeners may execute in an order different from the one in which they were registered.

      RuntimeExceptions thrown by a listener will be caught and logged. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException`) will be caught and logged.

      Specified by:
        `addListener` in interface `Service`
      Parameters:
        `listener` - the listener to run when the service changes state is complete
        `executor` - the executor in which the listeners callback methods will be run. For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`.
      Since:
        13.0

    - #### failureCause

          public final java.lang.Throwable failureCause()

      Description copied from interface: `Service`
      Returns the `Throwable` that caused this service to fail.
      Specified by:
        `failureCause` in interface `Service`
      Since:
        14.0

    - #### startAsync

          public final Service startAsync()

      Description copied from interface: `Service`
      If the service state is `Service.State.NEW`, this initiates service startup and returns immediately. A stopped service may not be restarted.
      Specified by:
        `startAsync` in interface `Service`
      Returns:
        this
      Since:
        15.0

    - #### stopAsync

          public final Service stopAsync()

      Description copied from interface: `Service`
      If the service is starting or running, this initiates service shutdown and returns immediately. If the service is new, it is terminated without having been started nor stopped. If the service has already been stopped, this method returns immediately without taking action.
      Specified by:
        `stopAsync` in interface `Service`
      Returns:
        this
      Since:
        15.0

    - #### awaitRunning

          public final void awaitRunning()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state.
      Specified by:
        `awaitRunning` in interface `Service`
      Since:
        15.0

    - #### awaitRunning

          public final void awaitRunning(long timeout,
                          java.util.concurrent.TimeUnit unit)
                                  throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state for no more than the given time.
      Specified by:
        `awaitRunning` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
      Since:
        15.0

    - #### awaitTerminated

          public final void awaitTerminated()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the terminated state.
      Specified by:
        `awaitTerminated` in interface `Service`
      Since:
        15.0

    - #### awaitTerminated

          public final void awaitTerminated(long timeout,
                             java.util.concurrent.TimeUnit unit)
                                     throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
      Specified by:
        `awaitTerminated` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
      Since:
        15.0

    - #### serviceName

          protected java.lang.String serviceName()

      Returns the name of this service. `AbstractExecutionThreadService` may include the name in debugging output.

      Subclasses may override this method.

      Since:
        14.0 (present in 10.0 as getServiceName)